package net.shadowfacts.phycon.plugin.rei

import net.minecraft.text.LiteralText
import net.minecraft.util.Identifier
import net.shadowfacts.phycon.PhysicalConnectivity
import net.shadowfacts.phycon.api.TerminalSetting

/**
 * @author shadowfacts
 */
enum class REISyncMode: TerminalSetting {
    OFF,
    ON,
    HIGHLIGHT_ONLY;

    override fun getIconTexture() = Identifier(PhysicalConnectivity.MODID, "textures/gui/terminal.png")

    override fun getUV() = when (this) {
        OFF -> intArrayOf(0, 240)
        ON -> intArrayOf(16, 240)
        HIGHLIGHT_ONLY -> intArrayOf(32, 240)
    }

    override fun getTooltip() = when (this) {
        OFF -> LiteralText("Don't sync with REI")
        ON -> LiteralText("Sync with REI")
        HIGHLIGHT_ONLY -> LiteralText("Sync in highlight mode")
    }
}
