package net.shadowfacts.phycon.client

import net.fabricmc.fabric.api.client.model.ModelProviderContext
import net.fabricmc.fabric.api.client.model.ModelResourceProvider
import net.minecraft.client.render.model.UnbakedModel
import net.minecraft.resource.ResourceManager
import net.minecraft.util.Identifier
import net.shadowfacts.phycon.PhysicalConnectivity
import net.shadowfacts.phycon.client.model.ScreenDeviceModel

/**
 * @author shadowfacts
 */
class PhyExtendedModelProvider(resourceManager: ResourceManager): ModelResourceProvider {

	companion object {
		val TERMINAL = Identifier(PhysicalConnectivity.MODID, "block/terminal")
		val CRAFTING_TERMINAL = Identifier(PhysicalConnectivity.MODID, "block/crafting_terminal")
	}

	override fun loadModelResource(resourceId: Identifier, context: ModelProviderContext): UnbakedModel? {
		return when (resourceId) {
			TERMINAL -> ScreenDeviceModel(TERMINAL)
			CRAFTING_TERMINAL -> ScreenDeviceModel(CRAFTING_TERMINAL)
			else -> null
		}
	}

}
