package net.shadowfacts.phycon.util

import net.minecraft.text.LiteralText
import net.minecraft.text.Text
import net.minecraft.util.Identifier
import net.shadowfacts.phycon.PhysicalConnectivity
import net.shadowfacts.phycon.api.TerminalSetting

/**
 * @author shadowfacts
 */
enum class SortMode: TerminalSetting {
	COUNT_HIGH_FIRST,
	COUNT_LOW_FIRST,
	ALPHABETICAL;

	override fun getIconTexture() = Identifier(PhysicalConnectivity.MODID, "textures/gui/terminal.png")

	override fun getUV() = when (this) {
		COUNT_HIGH_FIRST -> intArrayOf(0, 224)
		COUNT_LOW_FIRST -> intArrayOf(16, 224)
		ALPHABETICAL -> intArrayOf(32, 224)
	}

	override fun getTooltip() = when (this) {
		COUNT_HIGH_FIRST -> LiteralText("Count, highest first")
		COUNT_LOW_FIRST -> LiteralText("Count, lowest first")
		ALPHABETICAL -> LiteralText("Name")
	}

}
